Index: /trunk/sources/HeuristicLab.Core/3.3/Attributes/CreatableAttribute.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Attributes/CreatableAttribute.cs	(revision 12648)
+++ /trunk/sources/HeuristicLab.Core/3.3/Attributes/CreatableAttribute.cs	(revision 12649)
@@ -61,5 +61,4 @@
         return tokens.Take(tokens.Count - 1);
       }
-
       private static IEnumerable<string> GetTokensWithOrdering(string rawName) {
         return rawName.Split(new[] { SplitToken }, StringSplitOptions.RemoveEmptyEntries);
@@ -84,5 +83,4 @@
 
     public int Priority { get; set; }
-
 
     public CreatableAttribute() {
@@ -112,5 +110,4 @@
       else return null;
     }
-
     public static int GetPriority(Type type) {
       var attribs = type.GetCustomAttributes(typeof(CreatableAttribute), false);
Index: /trunk/sources/HeuristicLab.Optimizer/3.3/NewItemDialog.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimizer/3.3/NewItemDialog.cs	(revision 12648)
+++ /trunk/sources/HeuristicLab.Optimizer/3.3/NewItemDialog.cs	(revision 12649)
@@ -27,4 +27,5 @@
 using System.Windows.Forms;
 using HeuristicLab.Common;
+using HeuristicLab.Common.Resources;
 using HeuristicLab.Core;
 using HeuristicLab.PluginInfrastructure;
@@ -93,6 +94,6 @@
 
     private TreeNode CreateCategoryTree(IEnumerable<IGrouping<string, Type>> categories) {
-      imageList.Images.Add(HeuristicLab.Common.Resources.VSImageLibrary.Class);      // default icon
-      imageList.Images.Add(HeuristicLab.Common.Resources.VSImageLibrary.Namespace);  // plugins
+      imageList.Images.Add(VSImageLibrary.Class);      // default icon
+      imageList.Images.Add(VSImageLibrary.Namespace);  // plugins
 
       var rootNode = new TreeNode();
@@ -109,8 +110,8 @@
 
         // Skip categories with same full name because the raw name can still be different (missing order)
-        if (rootNode.Nodes.Find(fullName, searchAllChildren: true).Length > 0)
+        if (rootNode.Nodes.Find(fullName, true).Length > 0)
           continue;
 
-        var categoryNode = new TreeNode(name, imageIndex: 1, selectedImageIndex: 1) {
+        var categoryNode = new TreeNode(name, 1, 1) {
           Name = fullName,
           Tag = rawName
@@ -133,8 +134,8 @@
         rawName = rawName == null ? rawParentName : rawName + CreatableAttribute.Categories.SplitToken + rawParentName;
         var fullName = CreatableAttribute.Categories.GetFullName(rawName);
-        parentNode = node.Nodes.Find(fullName, searchAllChildren: false).SingleOrDefault();
+        parentNode = node.Nodes.Find(fullName, false).SingleOrDefault();
         if (parentNode == null) {
           var name = CreatableAttribute.Categories.GetName(rawName);
-          parentNode = new TreeNode(name, imageIndex: 1, selectedImageIndex: 1) {
+          parentNode = new TreeNode(name, 1, 1) {
             Name = fullName,
             Tag = rawName
@@ -149,5 +150,5 @@
       foreach (var category in categories) {
         var fullName = CreatableAttribute.Categories.GetFullName(category.Key);
-        var categoryNode = node.Nodes.Find(fullName, searchAllChildren: true).Single();
+        var categoryNode = node.Nodes.Find(fullName, true).Single();
         foreach (var creatable in category) {
           var itemNode = CreateItemNode(creatable);
@@ -323,5 +324,5 @@
     private void RestoreSelectedNode(TreeNode selectedNode) {
       if (selectedNode != null) {
-        var node = typesTreeView.Nodes.Find(selectedNode.Name, searchAllChildren: true).SingleOrDefault();
+        var node = typesTreeView.Nodes.Find(selectedNode.Name, true).SingleOrDefault();
         if (node != null)
           typesTreeView.SelectedNode = node;
@@ -360,5 +361,5 @@
     }
 
-    private TreeNode toolStripMenuNode = null;
+    private TreeNode toolStripMenuNode;
     private void typesTreeView_MouseDown(object sender, MouseEventArgs e) {
       if (e.Button == MouseButtons.Right) {
@@ -440,11 +441,4 @@
       }
     }
-    private TreeNode LastVisibleNode {
-      get {
-        var node = FirstVisibleNode;
-        while (node != null && node.NextVisibleNode != null) node = node.NextVisibleNode;
-        return node;
-      }
-    }
 
     private class ItemTreeNodeComparer : IComparer {
@@ -456,8 +450,9 @@
         if (lhs.Tag is string && rhs.Tag is string) {
           return Comparer.Compare((string)lhs.Tag, (string)rhs.Tag);
-        } else if (lhs.Tag is string) {
+        }
+        if (lhs.Tag is string) {
           return -1;
-        } else
-          return 1;
+        }
+        return 1;
       }
     }