Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.0.7/HeuristicLab.SimSharp-3.0.7/HeuristicLab.SimSharp-3.0.7.csproj
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.0.7/HeuristicLab.SimSharp-3.0.7/HeuristicLab.SimSharp-3.0.7.csproj	(revision 12670)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.0.7/HeuristicLab.SimSharp-3.0.7/HeuristicLab.SimSharp-3.0.7.csproj	(revision 12671)
@@ -78,5 +78,7 @@
   </ItemGroup>
   <ItemGroup>
+    <None Include="Plugin.cs.frame" />
     <Compile Include="Plugin.cs" />
+    <None Include="Properties\AssemblyInfo.cs.frame" />
     <Compile Include="Properties\AssemblyInfo.cs" />
   </ItemGroup>
@@ -101,4 +103,13 @@
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <PropertyGroup>
+    <PreBuildEvent>set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set Outdir=$(Outdir)
+
+call PreBuildEvent.cmd
+</PreBuildEvent>
+  </PropertyGroup>
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
        Other similar extension points exist, see Microsoft.Common.targets.
Index: unk/sources/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.0.7/HeuristicLab.SimSharp-3.0.7/Plugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.0.7/HeuristicLab.SimSharp-3.0.7/Plugin.cs	(revision 12670)
+++ 	(revision )
@@ -1,31 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.PluginInfrastructure;
-
-namespace HeuristicLab.SimSharp {
-  [Plugin("HeuristicLab.SimSharp", "Transport plugin for the simulation framework Sim#", "3.0.7")]
-  [PluginFile("HeuristicLab.SimSharp-3.0.7.dll", PluginFileType.Assembly)]
-  [PluginFile("SimSharp-3.0.7.dll", PluginFileType.Assembly)]
-  [PluginFile("SimSharp-3.0.7 License.txt", PluginFileType.License)]
-  public class Plugin : PluginBase {
-  }
-}
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.0.7/HeuristicLab.SimSharp-3.0.7/Plugin.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.0.7/HeuristicLab.SimSharp-3.0.7/Plugin.cs.frame	(revision 12671)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.0.7/HeuristicLab.SimSharp-3.0.7/Plugin.cs.frame	(revision 12671)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.SimSharp {
+  [Plugin("HeuristicLab.SimSharp", "Transport plugin for the simulation framework Sim#", "3.0.7.$WCREV$")]
+  [PluginFile("HeuristicLab.SimSharp-3.0.7.dll", PluginFileType.Assembly)]
+  [PluginFile("SimSharp-3.0.7.dll", PluginFileType.Assembly)]
+  [PluginFile("SimSharp-3.0.7 License.txt", PluginFileType.License)]
+  public class HeuristicLabSimSharpPlugin : PluginBase {
+  }
+}
Index: unk/sources/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.0.7/HeuristicLab.SimSharp-3.0.7/Properties/AssemblyInfo.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.0.7/HeuristicLab.SimSharp-3.0.7/Properties/AssemblyInfo.cs	(revision 12670)
+++ 	(revision )
@@ -1,35 +1,0 @@
-﻿using System.Reflection;
-using System.Runtime.InteropServices;
-
-// General Information about an assembly is controlled through the following 
-// set of attributes. Change these attribute values to modify the information
-// associated with an assembly.
-[assembly: AssemblyTitle("HeuristicLab.SimSharp-3.0.7")]
-[assembly: AssemblyDescription("Transport plugin for the simulation framework Sim#")]
-[assembly: AssemblyConfiguration("")]
-[assembly: AssemblyCompany("HEAL")]
-[assembly: AssemblyProduct("HeuristicLab")]
-[assembly: AssemblyCopyright("(c) 2002-2015 HEAL")]
-[assembly: AssemblyTrademark("")]
-[assembly: AssemblyCulture("")]
-
-// Setting ComVisible to false makes the types in this assembly not visible 
-// to COM components.  If you need to access a type in this assembly from 
-// COM, set the ComVisible attribute to true on that type.
-[assembly: ComVisible(false)]
-
-// The following GUID is for the ID of the typelib if this project is exposed to COM
-[assembly: Guid("15bc80f5-e0b9-4481-bab1-289d1403f877")]
-
-// Version information for an assembly consists of the following four values:
-//
-//      Major Version
-//      Minor Version 
-//      Build Number
-//      Revision
-//
-// You can specify all the values or you can default the Build and Revision Numbers 
-// by using the '*' as shown below:
-// [assembly: AssemblyVersion("1.0.*")]
-[assembly: AssemblyVersion("3.0.7.0")]
-[assembly: AssemblyFileVersion("3.0.7.0")]
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.0.7/HeuristicLab.SimSharp-3.0.7/Properties/AssemblyInfo.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.0.7/HeuristicLab.SimSharp-3.0.7/Properties/AssemblyInfo.cs.frame	(revision 12671)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.0.7/HeuristicLab.SimSharp-3.0.7/Properties/AssemblyInfo.cs.frame	(revision 12671)
@@ -0,0 +1,35 @@
+﻿using System.Reflection;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.SimSharp-3.0.7")]
+[assembly: AssemblyDescription("Transport plugin for the simulation framework Sim#")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("HEAL")]
+[assembly: AssemblyProduct("HeuristicLab")]
+[assembly: AssemblyCopyright("(c) 2002-2015 HEAL")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("15bc80f5-e0b9-4481-bab1-289d1403f877")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("3.0.7.0")]
+[assembly: AssemblyFileVersion("3.0.7.$WCREV$")]